import { StyleObjectOrFn } from '@chakra-ui/styled-system';
import { HTMLAttributes } from 'vue';

type StyleAndHTMLAttibutes = StyleObjectOrFn & Record<string, string | number | boolean | unknown> & HTMLAttributes;
interface ExtractedStyleAttrs {
    styles: Partial<StyleAndHTMLAttibutes>;
    attrs: Partial<HTMLAttributes>;
}
/** Extracts CSS style properties and HTML attributes from merged component attributs */
declare const extractStyleAttrs: <T extends StyleAndHTMLAttibutes, U extends Partial<HTMLAttributes> | Record<string, string | number | boolean>>(styleProps: T) => ExtractedStyleAttrs;

export { StyleAndHTMLAttibutes, extractStyleAttrs };
