import {
  debounce
} from "./chunk-LOPJBGHY.mjs";
import {
  __name
} from "./chunk-INDHDMU3.mjs";

// src/dom.ts
import { customRef, onBeforeUpdate, ref, unref } from "vue";
import { canUseDOM } from "@chakra-ui/utils";
function useRef() {
  const refEl = ref(null);
  onBeforeUpdate(() => {
    refEl.value = null;
  });
  const _ref = /* @__PURE__ */ __name((el) => {
    var _a;
    refEl.value = (_a = el == null ? void 0 : el.$el) != null ? _a : el;
  }, "_ref");
  return [_ref, refEl];
}
__name(useRef, "useRef");
function unrefElement(elementRef) {
  var _a;
  const node = unref(elementRef);
  return (_a = node == null ? void 0 : node.$el) != null ? _a : node;
}
__name(unrefElement, "unrefElement");
function useDebouncedRef(initialValue, delay = 300, immediate = false) {
  const state = ref(initialValue);
  const debouncedRef = customRef((track, trigger) => ({
    get() {
      track();
      return state.value;
    },
    set: debounce((value) => {
      state.value = value;
      trigger();
    }, delay, immediate)
  }));
  return debouncedRef;
}
__name(useDebouncedRef, "useDebouncedRef");
function contains(containers, element) {
  for (let container of containers) {
    if (container.contains(element))
      return true;
  }
  return false;
}
__name(contains, "contains");
var defaultWindow = /* @__PURE__ */ canUseDOM() ? window : void 0;
var defaultDocument = /* @__PURE__ */ canUseDOM() ? window.document : void 0;
var defaultNavigator = /* @__PURE__ */ canUseDOM() ? window.navigator : void 0;
var defaultLocation = /* @__PURE__ */ canUseDOM() ? window.location : void 0;

export {
  useRef,
  unrefElement,
  useDebouncedRef,
  contains,
  defaultWindow,
  defaultDocument,
  defaultNavigator,
  defaultLocation
};
